--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -8235,6 +8454,10 @@
 //        }
     }
 
+    //----------------------------------------------------------------------
+    // General helper routines
+    //
+
     private void disableAttribForRaster(GL gl) {
 
         gl.glDisable(GL2.GL_COLOR_MATERIAL);
@@ -8269,13 +8492,6 @@
         dst[15] = src[15];
     }
 
-    // ---------------------------------------------------------------------
-
-    //
-    // Canvas3D / GraphicsConfigTemplate3D methods - logic dealing with
-    // native graphics configuration or drawing surface
-    //
-
     // Return a graphics config based on the one passed in. Note that we can
     // assert that the input config is non-null and was created from a
     // GraphicsConfigTemplate3D.
@@ -8285,22 +8501,16 @@
     GraphicsConfiguration getGraphicsConfig(GraphicsConfiguration gconfig) {
         if (VERBOSE) System.err.println("JoglPipeline.getGraphicsConfig()");
 
-		GraphicsConfigInfo       gcInf0    = Canvas3D.graphicsConfigTable.get(gconfig);
-		AWTGraphicsConfiguration awtConfig = (AWTGraphicsConfiguration)gcInf0.getPrivateData();
+        GraphicsConfigInfo gcInf0 = Canvas3D.graphicsConfigTable.get(gconfig);
+        AWTGraphicsConfiguration awtConfig = (AWTGraphicsConfiguration) gcInf0.getPrivateData();
 
-    	return awtConfig.getAWTGraphicsConfiguration();
+        return awtConfig.getAWTGraphicsConfiguration();
     }
 
-	private enum DisabledCaps {
-		STEREO,
-		AA,
-		DOUBLE_BUFFER,
-	}
-
     // Get best graphics config from pipeline
     @Override
     GraphicsConfiguration getBestConfiguration(GraphicsConfigTemplate3D gct,
-            GraphicsConfiguration[] gc) {
+                                               GraphicsConfiguration[] gc) {
         if (VERBOSE) System.err.println("JoglPipeline.getBestConfiguration()");
 
         // Create a GLCapabilities based on the GraphicsConfigTemplate3D
@@ -8312,7 +8522,7 @@
 
         // Scene antialiasing only if double buffering
         if (gct.getSceneAntialiasing() != GraphicsConfigTemplate.UNNECESSARY &&
-            gct.getDoubleBuffer() != GraphicsConfigTemplate.UNNECESSARY) {
+                gct.getDoubleBuffer() != GraphicsConfigTemplate.UNNECESSARY) {
             caps.setSampleBuffers(true);
             int numSamples = MasterControl.getIntegerProperty("j3d.numSamples", 2);
             caps.setNumSamples(numSamples);
@@ -8348,7 +8558,7 @@
 
         // if AA is required, so is double buffering.
         if (gct.getSceneAntialiasing() != GraphicsConfigTemplate.REQUIRED &&
-            gct.getDoubleBuffer() == GraphicsConfigTemplate.PREFERRED) {
+                gct.getDoubleBuffer() == GraphicsConfigTemplate.PREFERRED) {
             capsToDisable.add(DisabledCaps.DOUBLE_BUFFER);
         }
 
@@ -8356,9 +8566,9 @@
         // Pick an arbitrary graphics device.
         GraphicsDevice device = gc[0].getDevice();
         AbstractGraphicsScreen screen = (device != null) ? AWTGraphicsScreen.createScreenDevice(device, AbstractGraphicsDevice.DEFAULT_UNIT) :
-            AWTGraphicsScreen.createDefault();
+                AWTGraphicsScreen.createDefault();
 
-     // Create a Frame and dummy GLCanvas to perform eager pixel format selection
+        // Create a Frame and dummy GLCanvas to perform eager pixel format selection
 
         // Note that we loop in similar fashion to the NativePipeline's
         // native code in the situation where we need to disable certain
@@ -8366,24 +8576,35 @@
         boolean tryAgain = true;
         CapabilitiesCapturer capturer = null;
         AWTGraphicsConfiguration awtConfig = null;
-        while (tryAgain) {
+
+
+        // while statement switched off due to JVM 9 crash
+
+        //while (tryAgain)
+        {
             Frame f = new Frame(device.getDefaultConfiguration());
             f.setUndecorated(true);
             f.setLayout(new BorderLayout());
             capturer = new CapabilitiesCapturer();
+
             try {
                 awtConfig = createAwtGraphicsConfiguration(caps, capturer, screen);
                 QueryCanvas canvas = new QueryCanvas(awtConfig, capturer);
                 f.add(canvas, BorderLayout.CENTER);
                 f.setSize(MIN_FRAME_SIZE, MIN_FRAME_SIZE);
                 f.setVisible(true);
+
+                // Potential JVM 9 CRASH occurs here on MacOS
                 canvas.doQuery();
+
                 if (DEBUG_CONFIG) {
                     System.err.println("Waiting for CapabilitiesCapturer");
                 }
+
+
                 // Try to wait for result without blocking EDT
                 if (!EventQueue.isDispatchThread()) {
-                    synchronized(capturer) {
+                    synchronized (capturer) {
                         if (!capturer.done()) {
                             try {
                                 capturer.wait(WAIT_TIME);
@@ -8394,27 +8615,32 @@
                 }
                 disposeOnEDT(f);
                 tryAgain = false;
+
             } catch (GLException e) {
                 // Failure to select a pixel format; try switching off one
                 // of the only-preferred capabilities
+
                 if (capsToDisable.size() == 0) {
                     tryAgain = false;
+
                 } else {
+
                     switch (capsToDisable.remove(0)) {
-                    case STEREO:
-                        caps.setStereo(false);
-                        break;
-                    case AA:
-                        caps.setSampleBuffers(false);
-                        break;
-                    case DOUBLE_BUFFER:
-                        caps.setDoubleBuffered(false);
-                        break;
+                        case STEREO:
+                            caps.setStereo(false);
+                            break;
+                        case AA:
+                            caps.setSampleBuffers(false);
+                            break;
+                        case DOUBLE_BUFFER:
+                            caps.setDoubleBuffered(false);
+                            break;
                     }
                     awtConfig = null;
                 }
             }
         }
+
         int chosenIndex = capturer.getChosenIndex();
         GLCapabilities chosenCaps = null;
         if (chosenIndex < 0) {
@@ -8432,11 +8658,11 @@
             chosenCaps = capturer.getCapabilities();
         }
 
+        // JVM 9 CRASH found above this line
+
         // FIXME chosenIndex isn't used anymore, used -1 instead of finding it.
         JoglGraphicsConfiguration config = new JoglGraphicsConfiguration(chosenCaps, chosenIndex, device);
 
-
-
         // FIXME: because of the fact that JoglGraphicsConfiguration
         // doesn't override hashCode() or equals(), we will basically be
         // creating a new one each time getBestConfiguration() is
@@ -8450,7 +8676,7 @@
 
         synchronized (Canvas3D.graphicsConfigTable) {
             Canvas3D.graphicsConfigTable.put(config, gcInf0);
-          }
+        }
 
         return config;
     }
@@ -8458,7 +8684,7 @@
     // Determine whether specified graphics config is supported by pipeline
     @Override
     boolean isGraphicsConfigSupported(GraphicsConfigTemplate3D gct,
-            GraphicsConfiguration gc) {
+                                      GraphicsConfiguration gc) {
         if (VERBOSE) System.err.println("JoglPipeline.isGraphicsConfigSupported()");
 
         // FIXME: it looks like this method is implemented incorrectly
@@ -8522,8 +8748,6 @@
                 caps.getAccumBlueBits() > 0);
     }
 
-    private boolean checkedForGetScreenMethod = false;
-    private Method getScreenMethod = null;
     @Override
     int getScreen(final GraphicsDevice graphicsDevice) {
         if (VERBOSE) System.err.println("JoglPipeline.getScreen()");
@@ -8536,7 +8760,7 @@
                 @Override
                 public Object run() {
                     try {
-                        getScreenMethod = graphicsDevice.getClass().getDeclaredMethod("getScreen", new Class[] {});
+                        getScreenMethod = graphicsDevice.getClass().getDeclaredMethod("getScreen", new Class[]{});
                         getScreenMethod.setAccessible(true);
                     } catch (Exception e) {
                     }
@@ -8557,14 +8781,125 @@
         return 0;
     }
 
-    //----------------------------------------------------------------------
-    // Helper classes and methods to support query context functionality
-    // and pixel format selection
+    private void disposeOnEDT(final Frame f) {
+        Runnable r = new Runnable() {
+            @Override
+            public void run() {
+                f.setVisible(false);
+                f.dispose();
+            }
+        };
+        if (!EventQueue.isDispatchThread()) {
+            EventQueue.invokeLater(r);
+        } else {
+            r.run();
+        }
+    }
+
+    // Method to construct a new DrawingSurfaceObject
+    @Override
+    DrawingSurfaceObject createDrawingSurfaceObject(Canvas3D cv) {
+        if (VERBOSE) System.err.println("JoglPipeline.createDrawingSurfaceObject()");
+        return new JoglDrawingSurfaceObject(cv);
+    }
+
+    // Method to free the drawing surface object
+    @Override
+    void freeDrawingSurface(Canvas3D cv, DrawingSurfaceObject drawingSurfaceObject) {
+        if (VERBOSE) System.err.println("JoglPipeline.freeDrawingSurface()");
+        // This method is a no-op
+    }
+
+    // Method to free the native drawing surface object
+    @Override
+    void freeDrawingSurfaceNative(Object o) {
+        if (VERBOSE) System.err.println("JoglPipeline.freeDrawingSurfaceNative()");
+        // This method is a no-op
+    }
+
+    // Helper used everywhere
+    GLContext context(Context ctx) {
+        if (ctx == null)
+            return null;
+        return ((JoglContext) ctx).getGLContext();
+    }
+
+    // Helper used everywhere
+    GLDrawable drawable(Drawable drawable) {
+        if (drawable == null)
+            return null;
+        return ((JoglDrawable) drawable).getGLDrawable();
+    }
+
+    GLCapabilities caps(Canvas3D ctx) {
+        if (ctx.drawable != null) {
+            // latest state for on- and offscreen drawables
+            return (GLCapabilities) drawable(ctx.drawable).getChosenGLCapabilities();
+        } else {
+            // state at the time of 'getBestConfiguration'
+            return ((JoglGraphicsConfiguration) ctx.graphicsConfiguration).getGLCapabilities();
+        }
+    }
+
+    private enum DisabledCaps {
+        STEREO,
+        AA,
+        DOUBLE_BUFFER,
+    }
 
     interface ExtendedCapabilitiesChooser extends GLCapabilitiesChooser {
         public void init(GLContext context);
     }
 
+    // Used in conjunction with IndexCapabilitiesChooser in pixel format
+    // selection -- see getBestConfiguration
+    static class CapabilitiesCapturer extends DefaultGLCapabilitiesChooser implements ExtendedCapabilitiesChooser {
+        private boolean done;
+        private GLCapabilities capabilities;
+        private int chosenIndex = -1;
+
+        public boolean done() {
+            return done;
+        }
+
+        public GLCapabilities getCapabilities() {
+            return capabilities;
+        }
+
+        public int getChosenIndex() {
+            return chosenIndex;
+        }
+
+        public int chooseCapabilities(GLCapabilities desired,
+                                      GLCapabilities[] available,
+                                      int windowSystemRecommendedChoice) {
+            int res = super.chooseCapabilities(desired, Arrays.asList(available), windowSystemRecommendedChoice);
+            capabilities = available[res];
+            chosenIndex = res;
+            markDone();
+            return res;
+        }
+
+        @Override
+        public void init(GLContext context) {
+            // Avoid hanging things up for several seconds
+            kick();
+        }
+
+        private void markDone() {
+            synchronized (this) {
+                done = true;
+                notifyAll();
+            }
+        }
+
+        private void kick() {
+            synchronized (this) {
+                notifyAll();
+            }
+        }
+    }
+
     // Canvas subclass to help with various query operations such as the
     // "query context" mechanism and pixel format selection.
     // Must defeat and simplify the single-threading behavior of JOGL's
@@ -8581,7 +8916,7 @@
         private JAWTWindow nativeWindow = null;
 
         private QueryCanvas(AWTGraphicsConfiguration awtConfig,
-        		            ExtendedCapabilitiesChooser chooser) {
+                            ExtendedCapabilitiesChooser chooser) {
             // The platform-specific GLDrawableFactory will only provide a
             // non-null GraphicsConfiguration on platforms where this is
             // necessary (currently only X11, as Windows allows the pixel
@@ -8601,14 +8936,13 @@
         public void addNotify() {
             super.addNotify();
 
-    		nativeWindow = (JAWTWindow)NativeWindowFactory.getNativeWindow(this, awtConfig);
-			nativeWindow.lockSurface();
-		    try {
-	    		glDrawable = GLDrawableFactory.getFactory(profile).createGLDrawable(nativeWindow);
-		    }
-		    finally {
-		    	nativeWindow.unlockSurface();
-		    }
+            nativeWindow = (JAWTWindow) NativeWindowFactory.getNativeWindow(this, awtConfig);
+            nativeWindow.lockSurface();
+            try {
+                glDrawable = GLDrawableFactory.getFactory(profile).createGLDrawable(nativeWindow);
+            } finally {
+                nativeWindow.unlockSurface();
+            }
 
             glDrawable.setRealized(true);
         }
@@ -8628,76 +8962,26 @@
                     context.release();
                 }
             }
-            context.destroy();
-            alreadyRan = true;
-
-            glDrawable.setRealized(false);
-            nativeWindow.destroy();
-        }
-    }
-
-    private static AWTGraphicsConfiguration createAwtGraphicsConfiguration(GLCapabilities capabilities,
-            CapabilitiesChooser chooser,
-            AbstractGraphicsScreen screen) {
-        GraphicsConfigurationFactory factory = GraphicsConfigurationFactory.getFactory(AWTGraphicsDevice.class, GLCapabilities.class);
-        AWTGraphicsConfiguration awtGraphicsConfiguration = (AWTGraphicsConfiguration) factory.chooseGraphicsConfiguration(capabilities, capabilities,
-        chooser, screen, VisualIDHolder.VID_UNDEFINED);
-        return awtGraphicsConfiguration;
-    }
 
-    // Used in conjunction with IndexCapabilitiesChooser in pixel format
-    // selection -- see getBestConfiguration
-    static class CapabilitiesCapturer extends DefaultGLCapabilitiesChooser implements ExtendedCapabilitiesChooser {
-        private boolean done;
-        private GLCapabilities capabilities;
-        private int chosenIndex = -1;
-
-        public boolean done() {
-            return done;
-        }
+            // Potential JVM 9 CRASH occurs here on MacOS
+            // Other .destroy() methods have been removed
+            // TODO: correct .destroy() and use
+            //
+            // context.destroy();
 
-        public GLCapabilities getCapabilities() {
-            return capabilities;
-        }
-
-        public int getChosenIndex() {
-            return chosenIndex;
-        }
+            alreadyRan = true;
 
-        public int chooseCapabilities(GLCapabilities desired,
-                GLCapabilities[] available,
-                int windowSystemRecommendedChoice) {
-            int res = super.chooseCapabilities(desired, Arrays.asList(available), windowSystemRecommendedChoice);
-            capabilities = available[res];
-            chosenIndex = res;
-            markDone();
-            return res;
-        }
+            glDrawable.setRealized(false);
 
-        @Override
-        public void init(GLContext context) {
-            // Avoid hanging things up for several seconds
-            kick();
-        }
+            //nativeWindow.destroy();
 
-        private void markDone() {
-            synchronized (this) {
-                done = true;
-                notifyAll();
-            }
-        }
-
-        private void kick() {
-            synchronized (this) {
-                notifyAll();
-            }
         }
     }
 
     // Used to support the query context mechanism -- needs to be more
     // than just a GLCapabilitiesChooser
     private final class ContextQuerier extends DefaultGLCapabilitiesChooser
-                                              implements ExtendedCapabilitiesChooser {
+            implements ExtendedCapabilitiesChooser {
         private Canvas3D canvas;
         private boolean done;
 
@@ -8728,244 +9012,4 @@
             }
         }
     }
-
-    private void disposeOnEDT(final Frame f) {
-        Runnable r = new Runnable() {
-            @Override
-            public void run() {
-                f.setVisible(false);
-                f.dispose();
-            }
-        };
-        if (!EventQueue.isDispatchThread()) {
-            EventQueue.invokeLater(r);
-        } else {
-            r.run();
-        }
-    }
-
-
-    // ---------------------------------------------------------------------
-
-    //
-    // DrawingSurfaceObject methods
-    //
-
-    // Method to construct a new DrawingSurfaceObject
-    @Override
-    DrawingSurfaceObject createDrawingSurfaceObject(Canvas3D cv) {
-        if (VERBOSE) System.err.println("JoglPipeline.createDrawingSurfaceObject()");
-        return new JoglDrawingSurfaceObject(cv);
-    }
-
-    // Method to free the drawing surface object
-    @Override
-    void freeDrawingSurface(Canvas3D cv, DrawingSurfaceObject drawingSurfaceObject) {
-        if (VERBOSE) System.err.println("JoglPipeline.freeDrawingSurface()");
-        // This method is a no-op
-    }
-
-    // Method to free the native drawing surface object
-    @Override
-    void freeDrawingSurfaceNative(Object o) {
-        if (VERBOSE) System.err.println("JoglPipeline.freeDrawingSurfaceNative()");
-        // This method is a no-op
-    }
-
-    //----------------------------------------------------------------------
-    // Context-related routines
-    //
-
-    // Helper used everywhere
-    GLContext context(Context ctx) {
-        if (ctx == null)
-            return null;
-        return ((JoglContext) ctx).getGLContext();
-    }
-
-    // Helper used everywhere
-    GLDrawable drawable(Drawable drawable) {
-        if (drawable == null)
-            return null;
-        return ((JoglDrawable) drawable).getGLDrawable();
-    }
-
-    GLCapabilities caps(Canvas3D ctx) {
-    	if (ctx.drawable != null) {
-    		// latest state for on- and offscreen drawables
-    		return (GLCapabilities)drawable(ctx.drawable).getChosenGLCapabilities();
-    	}
-    	else {
-    		// state at the time of 'getBestConfiguration'
-        return ((JoglGraphicsConfiguration) ctx.graphicsConfiguration).getGLCapabilities();
-    }
-    }
-
-    //----------------------------------------------------------------------
-    // General helper routines
-    //
-
-    private static ThreadLocal<FloatBuffer> nioVertexTemp = new ThreadLocal<FloatBuffer>();
-    private static ThreadLocal<DoubleBuffer> nioVertexDoubleTemp = new ThreadLocal<DoubleBuffer>();
-    private static ThreadLocal<FloatBuffer> nioColorTemp = new ThreadLocal<FloatBuffer>();
-    private static ThreadLocal<ByteBuffer> nioColorByteTemp = new ThreadLocal<ByteBuffer>();
-    private static ThreadLocal<FloatBuffer> nioNormalTemp = new ThreadLocal<FloatBuffer>();
-    private static ThreadLocal<FloatBuffer[]> nioTexCoordSetTemp = new ThreadLocal<FloatBuffer[]>();
-    private static ThreadLocal<FloatBuffer[]> nioVertexAttrSetTemp = new ThreadLocal<FloatBuffer[]>();
-
-    private static FloatBuffer getVertexArrayBuffer(float[] vertexArray) {
-        return getVertexArrayBuffer(vertexArray, true);
-    }
-
-    private static FloatBuffer getVertexArrayBuffer(float[] vertexArray, boolean copyData) {
-        return getNIOBuffer(vertexArray, nioVertexTemp, copyData);
-    }
-
-    private static DoubleBuffer getVertexArrayBuffer(double[] vertexArray) {
-        return getVertexArrayBuffer(vertexArray, true);
-    }
-
-    private static DoubleBuffer getVertexArrayBuffer(double[] vertexArray, boolean copyData) {
-        return getNIOBuffer(vertexArray, nioVertexDoubleTemp, true);
-    }
-
-    private static FloatBuffer getColorArrayBuffer(float[] colorArray) {
-        return getColorArrayBuffer(colorArray, true);
-    }
-
-    private static FloatBuffer getColorArrayBuffer(float[] colorArray, boolean copyData) {
-        return getNIOBuffer(colorArray, nioColorTemp, true);
-    }
-
-    private static ByteBuffer getColorArrayBuffer(byte[] colorArray) {
-        return getColorArrayBuffer(colorArray, true);
-    }
-
-    private static ByteBuffer getColorArrayBuffer(byte[] colorArray, boolean copyData) {
-        return getNIOBuffer(colorArray, nioColorByteTemp, true);
-    }
-
-    private static FloatBuffer getNormalArrayBuffer(float[] normalArray) {
-        return getNormalArrayBuffer(normalArray, true);
-    }
-
-    private static FloatBuffer getNormalArrayBuffer(float[] normalArray, boolean copyData) {
-        return getNIOBuffer(normalArray, nioNormalTemp, true);
-    }
-
-    private static FloatBuffer[] getTexCoordSetBuffer(Object[] texCoordSet) {
-        return getNIOBuffer(texCoordSet, nioTexCoordSetTemp);
-    }
-
-    private static FloatBuffer[] getVertexAttrSetBuffer(Object[] vertexAttrSet) {
-        return getNIOBuffer(vertexAttrSet, nioVertexAttrSetTemp);
-    }
-
-    private static FloatBuffer getNIOBuffer(float[] array, ThreadLocal<FloatBuffer> threadLocal, boolean copyData) {
-        if (array == null) {
-            return null;
-        }
-        FloatBuffer buf = threadLocal.get();
-        if (buf == null) {
-			buf = Buffers.newDirectFloatBuffer(array.length);
-            threadLocal.set(buf);
-        } else {
-            buf.rewind();
-            if (buf.remaining() < array.length) {
-                int newSize = Math.max(2 * buf.remaining(), array.length);
-				buf = Buffers.newDirectFloatBuffer(newSize);
-                threadLocal.set(buf);
-            }
-        }
-        if (copyData) {
-            buf.put(array);
-            buf.rewind();
-        }
-        return buf;
-    }
-
-    private static DoubleBuffer getNIOBuffer(double[] array, ThreadLocal<DoubleBuffer> threadLocal, boolean copyData) {
-        if (array == null) {
-            return null;
-        }
-        DoubleBuffer buf = threadLocal.get();
-        if (buf == null) {
-			buf = Buffers.newDirectDoubleBuffer(array.length);
-            threadLocal.set(buf);
-        } else {
-            buf.rewind();
-            if (buf.remaining() < array.length) {
-                int newSize = Math.max(2 * buf.remaining(), array.length);
-				buf = Buffers.newDirectDoubleBuffer(newSize);
-                threadLocal.set(buf);
-            }
-        }
-        if (copyData) {
-            buf.put(array);
-            buf.rewind();
-        }
-        return buf;
-    }
-
-    private static ByteBuffer getNIOBuffer(byte[] array, ThreadLocal<ByteBuffer> threadLocal, boolean copyData) {
-        if (array == null) {
-            return null;
-        }
-        ByteBuffer buf = threadLocal.get();
-        if (buf == null) {
-			buf = Buffers.newDirectByteBuffer(array.length);
-            threadLocal.set(buf);
-        } else {
-            buf.rewind();
-            if (buf.remaining() < array.length) {
-                int newSize = Math.max(2 * buf.remaining(), array.length);
-				buf = Buffers.newDirectByteBuffer(newSize);
-                threadLocal.set(buf);
-            }
-        }
-        if (copyData) {
-            buf.put(array);
-            buf.rewind();
-        }
-        return buf;
-    }
-
-    private static FloatBuffer[] getNIOBuffer(Object[] array, ThreadLocal<FloatBuffer[]> threadLocal) {
-        if (array == null) {
-            return null;
-        }
-        FloatBuffer[] bufs = threadLocal.get();
-
-        // First resize array of FloatBuffers
-        if (bufs == null) {
-            bufs = new FloatBuffer[array.length];
-            threadLocal.set(bufs);
-        } else if (bufs.length < array.length) {
-            FloatBuffer[] newBufs = new FloatBuffer[array.length];
-            System.arraycopy(bufs, 0, newBufs, 0, bufs.length);
-            bufs = newBufs;
-            threadLocal.set(bufs);
-        }
-
-        // Now go down array of arrays, converting each into a direct FloatBuffer
-        for (int i = 0; i < array.length; i++) {
-            float[] cur = (float[]) array[i];
-            FloatBuffer buf = bufs[i];
-            if (buf == null) {
-				buf = Buffers.newDirectFloatBuffer(cur.length);
-                bufs[i] = buf;
-            } else {
-                buf.rewind();
-                if (buf.remaining() < cur.length) {
-                    int newSize = Math.max(2 * buf.remaining(), cur.length);
-					buf = Buffers.newDirectFloatBuffer(newSize);
-                    bufs[i] = buf;
-                }
-            }
-            buf.put(cur);
-            buf.rewind();
-        }
-
-        return bufs;
-    }
 }
